#include <avr/io.h>
#include <avr/wdt.h>

#define DUTY  0.8
#define CTOP  250000UL
#define CMP   ((unsigned long)(DUTY*CTOP))	// rl

int main(void)
{
	unsigned long cnt = 0;		// 32bit

	DDRC = 0x30;	// PC5/4o̓sɐݒ
	PORTC = 0x10;	// PC5/4̏o͂L/Hɐݒ

	for (;;) {
		wdt_reset();	// WDTZbg
		cnt++;
		if (cnt >= CTOP) {
			cnt = 0;
			PORTC |= 0x10;	// PC4̏o͂H
		}
		if (cnt == CMP) {
			PORTC &= ~0x10;	// PC4̏o͂L
		}
	}

	return 0;
}
