#include <avr/io.h>
#include <avr/wdt.h>

unsigned char sw;				// XCb`ϐ
unsigned char sw_flag;			// XCb`ωtO

#define CTOP 10000UL
void update_sw()
{
	static char stat = 0;
	static unsigned long cnt = 0;
	unsigned char tmp;			// ݂̃|[g   

	tmp = (~PINC >> 4) & 3;

	switch (stat) {
	case 0:
		if (sw != tmp) {
			cnt = CTOP;
			stat = 1;
		}
		break;
	case 1:
		cnt--;
		if (cnt == 0) {
			if (sw != tmp) {
				sw_flag = 1;	// tO𗧂Ă
				sw = tmp;	// ϐswXV  
			}
			stat = 0;
		}
		break;
	}
	return;
}

int main()
{
	DDRB = 0xFF;
	DDRC = 0x0F;
	DDRD = 0xF8;

	PORTB = 0x18;
	PORTC = 0x30;	// ̓svAbv
	PORTD = 0x00;

	for (;;) {	// Cxg[v
		wdt_reset();
		update_sw();
		  // XCb`ϐXV 
		  if (sw_flag) {	// XCb`ωo
			sw_flag = 0;	// tONA
			switch (sw) {	// ANV
			case 0:
				break;
			case 1:
				PORTB = (PORTB >> 7) | (PORTB << 1);
				break;
			case 2:
				PORTB = (PORTB << 7) | (PORTB >> 1);
				break;
			case 3:
				PORTB = ~PORTB;
				break;
			}
		}
	}
	return 0;
}
