#include"ringbuf.h"

struct ringbuffer
{
	char buf[N];				// obt@
	int n;						// Oobt@̃f[^
	int w;						// Ƀf[^ޏꏊ
	int r;						// Ƀf[^ǂݏoꏊ
};

static int write(struct ringbuffer *rb, char v)
{
	if (N <= rb->n)
		return 1;	// f[^t
	rb->n++;
	rb->buf[rb->w++] = v;
	if (rb->w == N)
		rb->w = 0;
	return 0;
}

static int read(struct ringbuffer *rb, char *vp)
{
	if (rb->n <= 0)
		return 1;	// f[^
	rb->n--;
	*vp = rb->buf[rb->r++];
	if (rb->r == N)
		rb->r = 0;
	return 0;
}


/* * * * * * * * * * * * * * */
static struct ringbuffer fifo1;	// MpOobt@
static struct ringbuffer fifo2;	// MpOobt@

int rx_read(char *vp)
{
	return read(&fifo1, vp);
}

int rx_write(char v)
{
	return write(&fifo1, v);
}

int tx_read(char *vp)
{
	return read(&fifo2, vp);
}

int tx_write(char v)
{
	return write(&fifo2, v);
}
