#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>

ISR(ADC_vect)
{
	TIFR1 = _BV(OCF1B);	// gKp̃tÕNA
	PORTB = ~(ADC >> 2);	// ϊlo LED ɕ\
}

int main(void)
{
	// LED  SW1,2 ̃|[gݒ
	DDRD = 0xFE;
	DDRC = 0x0F;
	DDRB = 0xFF;

	PORTD = 0x00;
	PORTC = 0x00;
	PORTB = 0x00;

	OCR1A = 49999;
	OCR1B = 0;
	TCCR1A = 0;
	TCCR1B = 0xA;	// PS=8, CTC, 50msƂCompBtO

	ADMUX = _BV(REFS0);	// REFd(AVCC)
	ADMUX |= 0x05;	// ADC͂ADC5ɐݒ
	ADCSRB = 5;	// gK(TIMER1_CompBtO)
	ADCSRA = _BV(ADEN) | 0x7 | _BV(ADATE) | _BV(ADIE);
	ADCSRA |= _BV(ADSC);	// ADIFNAƕϊJn

	sei();

	for (;;) {
		wdt_reset();
	}
	return 0;
}
