#include <avr/io.h>
#include <avr/wdt.h>

#define CTOP  5000UL
#define STEP  100

int main(void)
{
	unsigned long cnt = 0;		// 32bit
	unsigned long cmp = 0;

	DDRC = 0x30;	// PC5/4o̓sɐݒ
	PORTC = 0x10;	// PC5/4̏o͂L/Hɐݒ

	for (;;) {
		wdt_reset();	// WDTZbg
		cnt++;
		if (cnt >= CTOP) {
			cnt = 0;
			PORTC |= 0x10;	// PC4̏o͂H
			cmp += STEP;
			if (cmp >= CTOP) {
				cmp = 0;
			}
		}
		if (cnt == cmp) {
			PORTC &= ~0x10;	// PC4̏o͂L
		}
	}

	return 0;
}
