#include <avr/io.h>
#include <avr/wdt.h>

unsigned char sw;				// XCb`ϐ
unsigned char sw_flag;			// XCb`ωtO

void update_sw()
{
	unsigned char tmp;

	tmp = (~PINC >> 4) & 3;	//݂̓̓sǂݎ
	if (tmp != sw) {
		sw_flag = 1;	// tO𗧂Ă
		sw = tmp;	// XCb`ϐXV
	}
}

int main()
{
	DDRB = 0xFF;
	DDRC = 0x0F;
	DDRD = 0xFE;

	PORTB = 0x18;
	PORTC = 0x30;	// ̓svAbv
	PORTD = 0x00;

	for (;;) {
		wdt_reset();
		update_sw();	// XCb`ϐXV
		if (sw_flag) {	// XCb`ωo
			sw_flag = 0;	// tONA
			switch (sw) {	// ANV
			case 0:
				break;
			case 1:
				PORTB = (PORTB >> 7) | (PORTB << 1);
				break;
			case 2:
				PORTB = (PORTB << 7) | (PORTB >> 1);
				break;
			case 3:
				PORTB = ~PORTB;
				break;
			}
		}
	}
	return 0;

}
