#include<avr/io.h>
#include<avr/wdt.h>
#include<avr/interrupt.h>

ISR(TIMER1_OVF_vect)
{
	PORTC ^= 0x20;	// 0.52bɃI[o[t[
}

ISR(TIMER1_COMPA_vect)
{
	OCR1A = TCNT1 + 62499;	// 0.5bɍĂъ荞
	TIFR1 = _BV(OCF1A);	// RyA}b`AtONAidvj
	PORTC ^= 0x10;
}

ISR(TIMER1_COMPB_vect)
{
	OCR1B = TCNT1 + 1249;	// 0.01bɍĂъ荞
	TIFR1 = _BV(OCF1B);	// RyA}b`BtONAidvj
	PORTB++;
}

int main()
{
	DDRB = 0xFF;
	DDRC = 0x3F;
	DDRD = 0xFE;

	PORTD = 0x00;
	PORTC = 0x30;	// ̓svAbv
	PORTB = 0x01;

	TCNT0 = 0;	// JE^NA
	TIFR0 = 0x07;	// ^C}tOSNA
	OCR1A = 1;
	OCR1B = 1;

	TIMSK1 = _BV(OCIE1A) | _BV(OCIE1B) | _BV(TOIE1);

	// ^C}1m[}[h, vXP[64ŊJn
	TCCR1A = 0;
	TCCR1B = 3;
	sei();	// VXeŜ̊荞݋

	for (;;) {
		wdt_reset();
	}
	return 0;
}
