#include<avr/io.h>
#include<avr/wdt.h>
#include<avr/interrupt.h>

volatile unsigned char sw;		// XCb`ϐ
volatile unsigned char sw_flag;	// XCb`ωtO

ISR(PCINT1_vect)	// sω荞݃nh
{
	// `^O΍p
	OCR1A = TCNT1 + 500;	// rlAݒ(64ms)
	TIFR1 = _BV(OCF1A);	// Ry}b`AtONA
	TIMSK1 |= _BV(OCIE1A);	// RyA}b`A荞ݗL
}

ISR(TIMER1_COMPA_vect)
{
	// `^OIƔf
	sw = ~(PINC >> 4) & 3;	// ϐswXV
	sw_flag = 1;
	TIMSK1 &= ~_BV(OCIE1A);	// RyA}b`A荞ݖ
}

int main()
{
	DDRB = 0xFF;
	DDRC = 0x0F;
	DDRD = 0xFE;

	PORTD = 0x00;
	PORTC = 0x30;	// ̓svAbv
	PORTB = 0x18;
	PCICR = _BV(PCIE1);
	PCMSK1 = 0x30;

	TCNT0 = 0;	// JE^NA
	TIFR0 = 0x07;	// ^C}tOSNA

	// ^C}1m[}[h, vXP[1024ŊJn
	TCCR1A = 0x00;
	TCCR1B = 0x05;
	sei();	// VXeŜ̊荞݋

	for (;;) {
		wdt_reset();
		if (sw_flag) {
			sw_flag = 0;	// tONA
			switch (sw) {
			case 0:
				break;
			case 1:
				PORTB = (PORTB >> 7) | (PORTB << 1);
				break;
			case 2:
				PORTB = (PORTB << 7) | (PORTB >> 1);
				break;
			case 3:
				PORTB = ~PORTB;
				break;
			}
		}
	}
	return 0;
}
