#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>

#define BAUD 38400

volatile unsigned char c;

/* IɃXCb`ԂPCɑM */
ISR(TIMER1_COMPA_vect)
{
	c = ((~PINC >> 4) & 3) + 0x30;	// XCb`ԂASCIIR[hɒ
	UCSR0B |= _BV(UDRIE0);	// 󂫊荞ݗL
}

ISR(USART_UDRE_vect)
{
	UDR0 = c;
	UCSR0B &= ~_BV(UDRIE0);	// 󂫊荞ݖ
}

int main(void)
{
	DDRD = 0xFE;
	DDRC = 0x0F;
	DDRB = 0xFF;

	PORTD = 0x00;
	PORTC = 0x30;
	PORTB = 0x00;

	/* ʐMxݒ */
	UBRR0 = (F_CPU >> 4) / BAUD - 1;
	UCSR0A = 0;

	/* f[^8rbgCpeBȂCXgbvrbg1 */
	UCSR0C = 0x06;

	/* M̗L */
	UCSR0B = _BV(TXEN0);
	sei();

	/* ^C}荞݂̐ݒ */
	OCR1A = 3000;
	TCCR1A = 0x00;
	TCCR1B = 0x0D;
	TIMSK1 = _BV(OCIE1A);	// COMP A荞ݗL

	for (;;) {
		wdt_reset();
	}
	return 0;
}
